from inventory import weapon_attacks


# ******** Equipment ********
class Equipment:
    def __str__(self):
        return self.name


# Default Equipment Class:
class TemplateEquipmentClass(Equipment):
    def __init__(self):
        self.item_level = 0
        self.name = "template name"
        self.item_type = "template slot"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 0
        self.dexterity_required = 0
        self.wisdom_required = 0


class RustyKnife(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Rusty Knife"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.PalmDrive, weapon_attacks.Juggular]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 1
        self.ability_power_bonus = 2
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 0
        self.dexterity_required = 1
        self.wisdom_required = 0


class SteelDagger(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Steel Dagger"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.PalmDrive, weapon_attacks.Juggular]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 1
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 5
        self.ability_power_bonus = 5
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 4
        self.dexterity_required = 3
        self.wisdom_required = 0


class CeremonialDagger(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Ceremonial Gold Dagger"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.PalmDrive, weapon_attacks.Juggular]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        #  Attributes
        self.vitality_bonus = 3
        self.strength_bonus = 3
        self.dexterity_bonus = 3
        self.wisdom_bonus = 3
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 10
        self.ability_power_bonus = 10
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 12
        self.dexterity_required = 7
        self.wisdom_required = 0


class IronSword(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Iron Sword"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.Slash, weapon_attacks.Cleave]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 2
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 1
        self.dexterity_required = 1
        self.wisdom_required = 0


class ObsidianSword(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Obsidian Blade"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.Slash, weapon_attacks.Cleave]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 6
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 8
        self.dexterity_required = 5
        self.wisdom_required = 0


class DiamondSword(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Diamond Sword"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Stab, weapon_attacks.Slash, weapon_attacks.Cleave]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        #  Attributes
        self.vitality_bonus = 1
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 3
        # bonus stats
        self.health_bonus = 5
        self.attack_bonus = 15
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 12
        self.dexterity_required = 7
        self.wisdom_required = 0


class Hatchet(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Hatchet"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Slash, weapon_attacks.Cleave, weapon_attacks.Rend]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 3
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 2
        self.dexterity_required = 0
        self.wisdom_required = 0


class WarAxe(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "War Axe"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Slash, weapon_attacks.Cleave, weapon_attacks.Rend]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 8
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 10
        self.dexterity_required = 3
        self.wisdom_required = 0


class GreatAxe(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Great Axe"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.Slash, weapon_attacks.Cleave, weapon_attacks.Rend]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 2
        self.strength_bonus = 0
        self.dexterity_bonus = -1
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 10
        self.attack_bonus = 20
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 15
        self.dexterity_required = 5
        self.wisdom_required = 0


class ShortBow(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Short Bow"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.QuickShot, weapon_attacks.SharpShoot, weapon_attacks.Hamstring]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 3
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 0
        self.dexterity_required = 4
        self.wisdom_required = 0


class LongBow(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Long Bow"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.QuickShot, weapon_attacks.SharpShoot, weapon_attacks.Hamstring]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 8
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 3
        self.dexterity_required = 10
        self.wisdom_required = 0


class UnicornBow(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Unicorn Bone Long Bow"
        self.item_type = "weapon"
        self.attacks = [weapon_attacks.QuickShot, weapon_attacks.SharpShoot, weapon_attacks.Hamstring]
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 2
        self.dexterity_bonus = 3
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 22
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 5
        self.dexterity_required = 15
        self.wisdom_required = 0


class WoodenShield(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Wooden Shield"
        self.item_type = "shield"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 3
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 2
        self.dexterity_required = 2
        self.wisdom_required = 0


class SteelBuckler(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Steel Buckler"
        self.item_type = "shield"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 8
        self.ability_power_bonus = 0
        self.defence_bonus = 0
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 7
        self.dexterity_required = 5
        self.wisdom_required = 0


class AdamantiumShield(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Adamantium Kite Shield"
        self.item_type = "shield"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 7
        self.strength_bonus = 4
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 10
        self.defence_bonus = 22
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 15
        self.dexterity_required = 10
        self.wisdom_required = 0


class WovenArmor(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Woven Cloth Armor"
        self.item_type = "armor"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 5
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 2
        self.dexterity_required = 2
        self.wisdom_required = 0


class ChainMail(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Chain Mail Coif"
        self.item_type = "armor"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 15
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 7
        self.dexterity_required = 5
        self.wisdom_required = 0


class DragonscalePlate(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Dragonscale Gothic Plate"
        self.item_type = "armor"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 20
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 30
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 18
        self.dexterity_required = 12
        self.wisdom_required = 0


class BeaverHat(Equipment):
    def __init__(self):
        self.item_level = 1
        self.name = "Beaver Pelt Hat"
        self.item_type = "helm"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 3
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 2
        self.dexterity_required = 2
        self.wisdom_required = 0


class SteelHelm(Equipment):
    def __init__(self):
        self.item_level = 2
        self.name = "Steel Helm"
        self.item_type = "helm"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 0
        self.attack_bonus = 0
        self.ability_power_bonus = 0
        self.defence_bonus = 8
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 5
        self.dexterity_required = 5
        self.wisdom_required = 0


class GoldCrown(Equipment):
    def __init__(self):
        self.item_level = 3
        self.name = "Jewel Encrusted Gold Crown"
        self.item_type = "helm"
        self.attacks = []
        # status effect
        self.status_effect_duration = None
        self.status_effect_magnitude = None
        self.status_effect_name = None
        # Attributes
        self.vitality_bonus = 0
        self.strength_bonus = 0
        self.dexterity_bonus = 0
        self.wisdom_bonus = 0
        # bonus stats
        self.health_bonus = 15
        self.attack_bonus = 0
        self.ability_power_bonus = 10
        self.defence_bonus = 24
        # equip requirements
        self.vitality_required = 0
        self.strength_required = 15
        self.dexterity_required = 10
        self.wisdom_required = 0

